aboutsummaryrefslogtreecommitdiff
path: root/nix/sync-with-upstream
diff options
context:
space:
mode:
authorLudovic Courtès <ludo@gnu.org>2012-12-13 22:14:25 +0100
committerLudovic Courtès <ludo@gnu.org>2012-12-13 22:14:25 +0100
commit1e9824513c570370638b1bfe33bf1dba1f12be4a (patch)
treecb7bd7f0bebd42dbeabf2c8f09ae1d5144ac969b /nix/sync-with-upstream
parent70915c1a2ef72e7350b2a29d1d93e30643bce6f3 (diff)
parentb35c0f866c83288e64dcf5839d908705d416c317 (diff)
downloadguix-1e9824513c570370638b1bfe33bf1dba1f12be4a.tar
guix-1e9824513c570370638b1bfe33bf1dba1f12be4a.tar.gz
Merge branch 'nix-integration'
Conflicts: tests/guix-package.sh
Diffstat (limited to 'nix/sync-with-upstream')
-rwxr-xr-xnix/sync-with-upstream68
1 files changed, 68 insertions, 0 deletions
diff --git a/nix/sync-with-upstream b/nix/sync-with-upstream
new file mode 100755
index 0000000000..69bd1fbee7
--- /dev/null
+++ b/nix/sync-with-upstream
@@ -0,0 +1,68 @@
+#!/bin/sh
+# Guix --- Nix package management from Guile. -*- coding: utf-8 -*-
+# Copyright (C) 2012 Ludovic Courtès <ludo@gnu.org>
+#
+# This file is part of Guix.
+#
+# Guix is free software; you can redistribute it and/or modify it
+# under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 3 of the License, or (at
+# your option) any later version.
+#
+# Guix is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with Guix. If not, see <http://www.gnu.org/licenses/>.
+
+#
+# Update the local copy of Nix source code needed to build the daemon.
+# Assume GNU Coreutils and Git are available.
+#
+
+top_srcdir="${top_srcdir:-..}"
+
+log()
+{
+ echo "sync-with-upstream: $@" >&2
+}
+
+# checked_in_p FILE
+checked_in_p()
+{
+ ( cd "$top_srcdir" ;
+ git ls-tree HEAD -- "nix/$1" | grep "$1" > /dev/null )
+}
+
+if [ ! -d "$top_srcdir/build-aux" ]
+then
+ log "\`$top_srcdir' is not the valid top-level source directory"
+ exit 1
+fi
+
+set -e
+for upstream_file in `cd "$top_srcdir/nix-upstream/src" ;
+ find . -name \*.c -or -name \*.h -or -name \*.cc -or -name \*.hh \
+ -or -name \*.cpp -or -name \*.hpp -or -name \*.sql`
+do
+ if grep "$upstream_file" "$top_srcdir/daemon.am" > /dev/null
+ then
+ if checked_in_p "$upstream_file"
+ then
+ log "skipping \`$upstream_file', which has a checked-in copy"
+ else
+ ( cd "$top_srcdir/nix-upstream/src" && \
+ cp -v --parents "$upstream_file" ../../nix )
+ fi
+ else
+ log "skipping \`$upstream_file', which is not used"
+ fi
+done
+
+cp -v "$top_srcdir/nix-upstream/"{COPYING,AUTHORS} "$top_srcdir/nix"
+
+# Substitutions.
+sed -i "$top_srcdir/nix/libstore/gc.cc" \
+ -e 's|/nix/find-runtime-roots\.pl|/guix/list-runtime-roots|g'